#include "ESPWebMQTT.h"
#include "ESPCfg.h"

String pub_mask = "/esp/inf/";
String buf_recv;  // буфер чтения из UART


//---------------------------------------------------
class ESPApp : public ESPWebMQTTBase {
public:
  ESPApp() : ESPWebMQTTBase() {}
public:
  void UART_MQTT(); // Публикация из UART в MQTT  
};
//---------------------------------------------------

void ESPApp::UART_MQTT() {
  if (pubSubClient->connected()) {

  char ch;
  String pub_topic;
  String val;
  int pos_delim;
  unsigned long t;
  
   while (Serial.available())
   {
    ch = (char)Serial.read();
    //if (ch == '\r') continue;
    //if (ch == '\n') {
    if (ch == '\0') {  
 
     // Отладка в Serial
    #ifndef NOSERIAL
    Serial.println("recv: " + buf_recv);
    #endif        
        
     // поиск разделителя
    pos_delim = buf_recv.indexOf("=");
      // если строка в требуемом формате
     if (pos_delim != -1)
     {
      pub_topic = buf_recv.substring(0,pos_delim); // выделим тему
      val = buf_recv.substring(pos_delim+1);       // выделим значение
          
      #ifndef NOSERIAL
      t = millis(); // для отладки
      #endif  
          
       // публикация значения
      mqttPublish(pub_mask+pub_topic, String(val));

      #ifndef NOSERIAL
      Serial.println(millis()-t);
      #endif         
     }
     buf_recv = "";
     break;
    }
        buf_recv += ch;
   }   
  }
 }

ESPApp* app = new ESPApp();

void setup() {
  Serial.begin(9600);  
  Serial.println();
  app->setup();
}

void loop() {
  app->loop();
  app->UART_MQTT(); 
}
